﻿using System;
using System.Threading;
using System.Windows.Forms;
using System.Windows.Media;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using TestPlugin;

namespace AlphaPlugins
{
    public class GarrAbPlugin : HBPlugin
    {
        private int _maxMonsters = 1;

        public override string Name { get { return "GarrAb"; } }

        public override string Author { get { return "AlphaDog"; } }

        public override Version Version { get { return new Version(1, 0); } }
        public override bool WantButton { get { return true; } }

        public override void OnButtonPress()
        {
            SettingsDialog.GetInstance().ShowDialog();
            _maxMonsters = SettingsDialog.GetInstance().GetMonsterLimit();
            Logging.Write(Colors.Fuchsia, "[{0}] Monster limit set to: {1}", Name, _maxMonsters);

        }

        public override void OnEnable()
        {
            Logging.Write(Colors.ForestGreen, "[{0}] Plugin enabled", Name);
            Logging.Write(Colors.DodgerBlue, "GarrAb - A Garrison Ability plugin");
            Logging.Write(Colors.DodgerBlue, "By AlphaDog & DualYield");
            base.OnEnable();

        }

        public override void OnDisable()
        {
            Logging.Write(Colors.OrangeRed, "[{0}] Plugin disabled", Name);
            base.OnDisable();
        }


        public override void Pulse()
        {
            LocalPlayer localPlayer = StyxWoW.Me;
            if (!StyxWoW.IsInWorld || localPlayer == null || !localPlayer.IsValid || !localPlayer.IsAlive)
                return;
            if (!localPlayer.Combat)
                return;

            WoWSpell spell = WoWSpell.FromId(161767);
            if (spell == null)
            {
                Logging.Write(Colors.Red,  "[{0}] Can't find 'Guardian Orb' spell!", Name);
                return;
            }

            int attackingMonsterCount = ObjectManager.GetObjectsOfType<WoWUnit>().FindAll(unit => IsUnitValid(unit, 15) && unit.Aggro).Count;           
            if (attackingMonsterCount == 0) return;

            Logging.Write(Colors.DeepSkyBlue, "[{0}] Found {1} monsters that are attacking me!", Name, attackingMonsterCount);
            if (attackingMonsterCount >= _maxMonsters && SpellManager.CanCast(spell))
            {
                Logging.Write(Colors.Fuchsia, "[{0}] Casting: {1}", Name, spell.Name);
                SpellManager.Cast(spell);
            }
        }
     
        private bool IsUnitValid(WoWUnit unit, double range)
        {
            return unit != null && unit.IsValid && unit.IsAlive && unit.Attackable && unit.DistanceSqr <= range;
        }
    }
}
